"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var accounts_base_1 = require('meteor/accounts-base');
var tracker_1 = require('meteor/tracker');
var meteor_1 = require('meteor/meteor');
var LOGIN_TEMPLATE = "<div class=\"login-buttons\">  <div class=\"dropdown-toggle\"  *ngIf=\"isLoggedIn\" (click)=\"isDropdownOpen=isDropdownOpen?false:true\">    <span>      {{ displayName() }}    </span><!--     <span *ngIf=\"!isLoggedIn\">      登录    </span> -->  </div>  <div class=\"content-container\" [ngClass]=\"{'loggedIn':isLoggedIn}\" *ngIf=\"!isLoggedIn||isDropdownOpen\">    <div class=\"accounts-close\" *ngIf=\"isLoggedIn\" (click)=\"isDropdownOpen=false\">×</div>    <div *ngIf=\"isLoggedIn\">      <div class=\"login-text-and-button\" (click)=\"logout()\"><!--         <div class=\"login-display-name\">          {{ displayName() }}        </div> -->        <a class=\"login-buttons-logout\">退出</a>      </div>    </div>    <div *ngIf=\"!isLoggedIn\">      <span [hidden]=\"!isLoggingIn\"><img style=\"margin:2px 2px;\" src=\"/static/images/loading4.gif\"></span>      <form class=\"login-buttons-login-form\">        <div *ngIf=\"message == ''\">          <label for=\"email\">用户名／EMail</label>          <input class=\"login-buttons-email-input form-control\" type=\"email\" name= \"email\" required [(ngModel)]=\"credentials.email\"/>          <div [hidden]=\"isPasswordRecovery\">            <label for=\"password\">密码</label>            <input class=\"login-buttons-password-input form-control\" type=\"password\" name=\"password\" required                   [(ngModel)]=\"credentials.password\"/>          </div>        </div>        <br/>        <ul [hidden]=\"!errors || errors.length == 0\">          <li *ngFor=\"let error of errors\">            {{ error }}          </li>        </ul>        {{ message }}        <div *ngIf=\"message == ''\">          <button *ngIf=\"!isPasswordRecovery && !isSignup\" class=\"login-button-login\" (click)=\"login()\">登录</button><!--          <button *ngIf=\"!isPasswordRecovery && isSignup\" class=\"login-button-signup\" (click)=\"signup()\">注册          </button>-->          <!--<button *ngIf=\"isPasswordRecovery && !isSignup\" class=\"login-button-recover\" (click)=\"recover()\">Recover-->          <!--</button>-->        </div><!--         <br/>       <a [hidden]=\"isSignup\" class=\"signup-button\" (click)=\"isSignup=true; isPasswordRecovery=false; resetErrors();\">注册</a>-->        <!--<a [hidden]=\"isPasswordRecovery\" class=\"recover-button\"-->        <!--(click)=\"isPasswordRecovery=true; isSignup=false; resetErrors();\" href=\"#\">Recover Password</a>--><!--        <a [hidden]=\"!isSignup && !isPasswordRecovery\" class=\"login-button\"           (click)=\"isPasswordRecovery=false; isSignup=false; resetErrors();\">返回登录</a>-->      </form>    </div>  </div></div>";
var LoginButtons = (function () {
    function LoginButtons(zone) {
        this.zone = zone;
        this.isLoggedIn = true;
        this._initAutorun();
        this.services = this._getLoginServices();
        this.resetErrors();
        this.isPasswordRecovery = false;
        this.isSignup = false;
        this.isDropdownOpen = false;
        this._resetCredentialsFields();
    }
    LoginButtons.prototype._resetCredentialsFields = function () {
        this.credentials = { email: '', password: '' };
    };
    LoginButtons.prototype.resetErrors = function () {
        this.errors = [];
        this.message = "";
    };
    LoginButtons.prototype.singleService = function () {
        var services = this._getLoginServices();
        return services[0];
    };
    LoginButtons.prototype.displayName = function () {
        var user = this.currentUser;
        if (!user)
            return '';
        if (user.profile && user.profile.name)
            return user.profile.name;
        if (user.username)
            return user.username;
        if (user.emails && user.emails[0] && user.emails[0].address)
            return user.emails[0].address;
        return '';
    };
    ;
    LoginButtons.prototype.login = function () {
        var _this = this;
        this.resetErrors();
        var email = this.credentials.email;
        var password = this.credentials.password;
        meteor_1.Meteor.loginWithPassword(email, password, function (error) {
            if (error) {
                _this.errors.push(error.reason || "Unknown error");
            }
            else {
                _this.isDropdownOpen = false;
                _this._resetCredentialsFields();
            }
        });
    };
    /*  recover() {
        this.resetErrors();
    
        Accounts.forgotPassword({ email: this.credentials.email }, (error) => {
          if (error) {
            this.errors.push(error.reason || "Unknown error");
          }
          else {
            this.message = "You will receive further instruction to you email address!";
            this.isDropdownOpen = false;
            this._resetCredentialsFields();
          }
        });
      }*/
    LoginButtons.prototype.logout = function () {
        meteor_1.Meteor.logout();
        this.isDropdownOpen = false;
    };
    /*  signup(): void {
        this.resetErrors();
    
        Accounts.createUser(this.credentials, (error) => {
          if (error) {
            this.errors.push(error.reason || "Unknown error");
          }
          else {
            this.isDropdownOpen = false;
            this._resetCredentialsFields();
          }
        });
      }*/
    LoginButtons.prototype._hasPasswordService = function () {
        return !!Package['accounts-password'];
    };
    LoginButtons.prototype._getLoginServices = function () {
        var services = Package['accounts-oauth'] ? accounts_base_1.Accounts.oauth.serviceNames() : [];
        services.sort();
        if (this._hasPasswordService())
            services.push('password');
        return _.map(services, function (name) {
            return { name: name };
        });
    };
    LoginButtons.prototype.dropdown = function () {
        return this._hasPasswordService() || this._getLoginServices().length > 1;
    };
    LoginButtons.prototype._initAutorun = function () {
        var _this = this;
        this.autorunComputation = tracker_1.Tracker.autorun(function () {
            _this.zone.run(function () {
                _this.currentUser = meteor_1.Meteor.user();
                _this.currentUserId = meteor_1.Meteor.userId();
                _this.isLoggingIn = meteor_1.Meteor.loggingIn();
                _this.isLoggedIn = !!meteor_1.Meteor.user();
            });
        });
    };
    LoginButtons = __decorate([
        core_1.Component({
            selector: 'login-buttons',
            moduleId: meteor_1.Meteor.absoluteUrl(module.id),
            template: LOGIN_TEMPLATE,
            directives: [common_1.NgIf, common_1.NgFor]
        }), 
        __metadata('design:paramtypes', [core_1.NgZone])
    ], LoginButtons);
    return LoginButtons;
}());
exports.LoginButtons = LoginButtons;
//# sourceMappingURL=login-buttons.js.map